///////////////////////////////////////////////////////////
////// GibPascal pascal_main.h
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////

char version[10]="1.1.0a";

////pascal_math.c
int math_set(char *command, int debug);

int isOperator(char *check_char);                    //internal function
int isLetter(char check_char);                       //internal function 
int isOperand(char *check_char);                     //internal function
int calculate(char *op1, char *op, char *op2);       //internal function

///main math
int pascal_wround(int indent, int debug);            //implimented in 1.2

////pascal_system.c
void pascal_delay(char *command,int debug);          //new to ver 1.2
void pascal_halt();                                  //halts execution of code (ends program)
void g_pascal_system(char *command);                 //runs external code
void get_system(char *systemvar1,char *systemvar2);  //internal function
char *get_dir(int debug);


////pascal.c
void pascal_read(int indent);
void pascal_writeln(int indent, int debug);          //write() also uses this routine
void pascal_insert(int indent, int debug);
void pascal_if(int indent,int debug);
void pascal_until(int indent,int debug);
void pascal_if_subthread();                          //internal function 
void pascal_goto(int indent,int debug);
void pascal_goto_subthread(char temptext[60]);       //internal function
void pascal_rewrite(int indent);
void pascal_var(int debug);
void pascal_label(int debug);


void g_pascal_writewc(int indent, int debug);
void g_pascal_read_date(int indent);
void g_pascal_findrp(int indent, int debug);         //find replace string
void g_pascal_findow(int indent, int debug);
void g_pascal_read_version(int indent);

////pascal_string.c
char *pascal_concat(char *command, int debug);       //concat string
char *concat_set(char *command, int debug);
void pascal_delete(char *stread, int indent, int debug);

////pascal_web.c
void g_pascal_writewh(void);
void echo_wc(int spch);
void query_remote_web_client(void);
void read_http_user_agent(char *stread, int indent);
void read_query_string(char *stread,int indent);
void read_remote_addr(char *stread, int indent);
void read_content_length(char *stread,int indent);

////pascal_X11.c
void x_msgbox(char *command);
void x_open();
void x_close();
void x_radiobox(char *command);
void x_imgbox(char *command);
void x_createwindow(char *command);
