///////////////////////////////////////////////////////////
////// GibPascal pascal_system.c
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>



/////////////////////////////
// get current working dir
////////////////////////////
char *get_dir(int debug) {
    
   static char cwd[259];

   if (getcwd(cwd, sizeof(cwd)) != NULL) {
     if(debug==1)printf("**[GetDir] Current working dir: '%s'\n", cwd);
   } else {
       printf("Pascal Error: 015 getcwd() error");
       return 1;
   }

   if(debug==1)printf("**[GetDir ck2] Current working dir: '%s'\n", cwd);
   return cwd;
}

///////////////////////////////////
////// halt
////// Haults code and exits
//////////////////////////////////
void pascal_halt()
{
                                                                                                                             
 exit(0);
                                                                                                                             
}

///////////////////////////////////////////////////////////
// delay
// pauses/delays execution of commands for a period of time
// intro in ver 1.2
///////////////////////////////////////////////////////////
void pascal_delay(char *command, int debug)
{


  int delaytime=0;
  char systemtext[120];
  int loop=0, loop2=0;

  do{
    loop++;
  }while(command[loop]!='(');
  loop++;
                                                                                                                             
  do{                            
    systemtext[loop2]=command[loop];
    loop++;
    loop2++;
  }while(command[loop]!=')');
  systemtext[loop2]='\0';

  if(debug==1)printf("**[DELAY] delay=%s mill seconds \n",systemtext);
  
  delaytime=atoi(systemtext);

  delaytime=delaytime / 1000;

  if(debug==1)printf("**[DELAY] delay=%i seconds \n",delaytime);

  if(delaytime >=0) sleep(delaytime);

}

/////////////////////////////////////
////// system()
/////////////////////////////////////

void g_pascal_system(char *command)
{

  char systemtext[120];
  int loop=0, loop2=0;

  do{
    loop++;
  }while(command[loop]!='\'');
  loop++;
                                                                                                                             
  do{                            
    systemtext[loop2]=command[loop];
    loop++;
    loop2++;
  }while(command[loop]!='\'');
  systemtext[loop2]='\0';

  system(systemtext);

}

///////////////////////////////////////
////// get_system()
////// For Unix / Linux systems only
///////////////////////////////////////
void get_system(char *systemvar1, char *systemvar2)
{
  FILE *file_exist;

  //aix       /usr/bin/smit
  //mandrake  /etc/mandrake-release
  //redhat    /etc/redhat-release
  //debian    /etc/debian_version
  //SuSe      /etc/SuSE-release
  //Slackware /etc/slackware-release

   strcpy(systemvar1,"NULL");
   strcpy(systemvar2,"NULL");

   if ((file_exist = fopen("/etc/redhat-release", "r")) != NULL){
     strcpy(systemvar1,"redhat");
     fgets(systemvar2,100,file_exist);
     fclose(file_exist);   
   }

   if ((file_exist = fopen("/etc/mandrake-release", "r")) != NULL){
     strcpy(systemvar1,"mandrake");
     fgets(systemvar2,100,file_exist);
     fclose(file_exist);
   }

   if ((file_exist = fopen("/etc/SuSe-release", "r")) != NULL){
     strcpy(systemvar1,"suse");
     fgets(systemvar2,100,file_exist);
     fclose(file_exist);
   }

   if ((file_exist = fopen("/etc/slackware-release", "r")) != NULL){
     strcpy(systemvar1,"slackware");
     fgets(systemvar2,100,file_exist);
     fclose(file_exist);
   }

   if ((file_exist = fopen("/etc/debian_version", "r")) != NULL){
     strcpy(systemvar1,"debian");
     fgets(systemvar2,100,file_exist);
     fclose(file_exist);
   }

   if ((file_exist = fopen("/usr/bin/smit", "r")) != NULL){
     strcpy(systemvar1,"aix");
     fclose(file_exist);
   }


}

